Index: src/atom.cpp
===================================================================
--- src/atom.cpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/atom.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -1,2 +1,9 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
 /** \file atom.cpp
  *
@@ -4,4 +11,9 @@
  *
  */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
 
 #include "Helpers/MemDebug.hpp"
@@ -13,5 +25,5 @@
 #include "lists.hpp"
 #include "parser.hpp"
-#include "vector.hpp"
+#include "LinearAlgebra/Vector.hpp"
 #include "World.hpp"
 #include "molecule.hpp"
@@ -19,4 +31,5 @@
 
 #include <iomanip>
+#include <iostream>
 
 /************************************* Functions for class atom *************************************/
@@ -26,19 +39,20 @@
  */
 atom::atom() :
-  father(this), sort(&nr), mol(0)
-{
-  node = &x;  // TesselPoint::x can only be referenced from here
-};
+  father(this),
+  sort(&nr),
+  mol(0)
+{};
 
 /** Constructor of class atom.
  */
 atom::atom(atom *pointer) :
-    ParticleInfo(pointer),father(pointer), sort(&nr)
-{
-  type = pointer->type;  // copy element of atom
-  x = pointer->x; // copy coordination
-  v = pointer->v; // copy velocity
+    ParticleInfo(pointer),
+    father(pointer),
+    sort(&nr)
+{
+  setType(pointer->getType());  // copy element of atom
+  setPosition(pointer->getPosition()); // copy coordination
+  AtomicVelocity = pointer->AtomicVelocity; // copy velocity
   FixedIon = pointer->FixedIon;
-  node = &x;
   mol = 0;
 };
@@ -48,9 +62,8 @@
   res->father = this;
   res->sort = &res->nr;
-  res->type = type;
-  res->x = this->x;
-  res->v = this->v;
+  res->setType(getType());
+  res->setPosition(this->getPosition());
+  res->AtomicVelocity = this->AtomicVelocity;
   res->FixedIon = FixedIon;
-  res->node = &x;
   res->mol = 0;
   World::getInstance().registerAtom(res);
@@ -109,4 +122,8 @@
 };
 
+bool atom::isFather(const atom *ptr){
+  return ptr==father;
+}
+
 /** Checks whether atom is within the given box.
  * \param offset offset to box origin
@@ -116,5 +133,5 @@
 bool atom::IsInShape(const Shape& shape) const
 {
-  return shape.isInside(*node);
+  return shape.isInside(getPosition());
 };
 
@@ -141,8 +158,8 @@
   if (out != NULL) {
     *out << "Ion_Type" << ElementNo << "_" << AtomNo << "\t"  << fixed << setprecision(9) << showpoint;
-    *out << x[0] << "\t" << x[1] << "\t" << x[2];
+    *out << at(0) << "\t" << at(1) << "\t" << at(2);
     *out << "\t" << FixedIon;
-    if (v.Norm() > MYEPSILON)
-      *out << "\t" << scientific << setprecision(6) << v[0] << "\t" << v[1] << "\t" << v[2] << "\t";
+    if (AtomicVelocity.Norm() > MYEPSILON)
+      *out << "\t" << scientific << setprecision(6) << AtomicVelocity[0] << "\t" << AtomicVelocity[1] << "\t" << AtomicVelocity[2] << "\t";
     if (comment != NULL)
       *out << " # " << comment << endl;
@@ -161,13 +178,15 @@
   * \return true - \a *out present, false - \a *out is NULL
  */
-bool atom::OutputArrayIndexed(ostream * const out, const int *ElementNo, int *AtomNo, const char *comment) const
-{
-  AtomNo[type->Z]++;  // increment number
+bool atom::OutputArrayIndexed(ostream * const out,const enumeration<const element*> &elementLookup, int *AtomNo, const char *comment) const
+{
+  AtomNo[getType()->getAtomicNumber()]++;  // increment number
   if (out != NULL) {
-    *out << "Ion_Type" << ElementNo[type->Z] << "_" << AtomNo[type->Z] << "\t"  << fixed << setprecision(9) << showpoint;
-    *out << x[0] << "\t" << x[1] << "\t" << x[2];
+    const element *elemental = getType();
+    ASSERT(elementLookup.there.find(elemental)!=elementLookup.there.end(),"Type of this atom was not in the formula upon enumeration");
+    *out << "Ion_Type" << elementLookup.there.find(elemental)->second << "_" << AtomNo[elemental->getAtomicNumber()] << "\t"  << fixed << setprecision(9) << showpoint;
+    *out << at(0) << "\t" << at(1) << "\t" << at(2);
     *out << "\t" << FixedIon;
-    if (v.Norm() > MYEPSILON)
-      *out << "\t" << scientific << setprecision(6) << v[0] << "\t" << v[1] << "\t" << v[2] << "\t";
+    if (AtomicVelocity.Norm() > MYEPSILON)
+      *out << "\t" << scientific << setprecision(6) << AtomicVelocity[0] << "\t" << AtomicVelocity[1] << "\t" << AtomicVelocity[2] << "\t";
     if (comment != NULL)
       *out << " # " << comment << endl;
@@ -186,5 +205,5 @@
 {
   if (out != NULL) {
-    *out << type->symbol << "\t" << x[0] << "\t" << x[1] << "\t" << x[2] << "\t" << endl;
+    *out << getType()->getSymbol() << "\t" << at(0) << "\t" << at(1) << "\t" << at(2) << "\t" << endl;
     return true;
   } else
@@ -199,9 +218,11 @@
   * \return true - \a *out present, false - \a *out is NULL
  */
-bool atom::OutputTrajectory(ofstream * const out, const int *ElementNo, int *AtomNo, const int step) const
-{
-  AtomNo[type->Z]++;
+bool atom::OutputTrajectory(ofstream * const out, const enumeration<const element*> &elementLookup, int *AtomNo, const int step) const
+{
+  AtomNo[getType()->getAtomicNumber()]++;
   if (out != NULL) {
-    *out << "Ion_Type" << ElementNo[type->Z] << "_" << AtomNo[type->Z] << "\t"  << fixed << setprecision(9) << showpoint;
+    const element *elemental = getType();
+    ASSERT(elementLookup.there.find(elemental)!=elementLookup.there.end(),"Type of this atom was not in the formula upon enumeration");
+    *out << "Ion_Type" << elementLookup.there.find(elemental)->second << "_" << AtomNo[getType()->getAtomicNumber()] << "\t"  << fixed << setprecision(9) << showpoint;
     *out << Trajectory.R.at(step)[0] << "\t" << Trajectory.R.at(step)[1] << "\t" << Trajectory.R.at(step)[2];
     *out << "\t" << FixedIon;
@@ -224,5 +245,5 @@
 {
   if (out != NULL) {
-    *out << type->symbol << "\t";
+    *out << getType()->getSymbol() << "\t";
     *out << Trajectory.R.at(step)[0] << "\t";
     *out << Trajectory.R.at(step)[1] << "\t";
@@ -238,9 +259,9 @@
  * \param *AtomNo pointer to atom counter that is increased by one
  */
-void atom::OutputMPQCLine(ostream * const out, const Vector *center, int *AtomNo = NULL) const
-{
-  *out << "\t\t" << type->symbol << " [ " << x[0]-center->at(0) << "\t" << x[1]-center->at(1) << "\t" << x[2]-center->at(2) << " ]" << endl;
-  if (AtomNo != NULL)
-    *AtomNo++;
+void atom::OutputMPQCLine(ostream * const out, const Vector *center) const
+{
+  Vector recentered(getPosition());
+  recentered -= *center;
+  *out << "\t\t" << getType()->getSymbol() << " [ " << recentered[0] << "\t" << recentered[1] << "\t" << recentered[2] << " ]" << endl;
 };
 
@@ -263,5 +284,5 @@
 double atom::DistanceSquaredToVector(const Vector &origin) const
 {
-  return origin.DistanceSquared(x);
+  return DistanceSquared(origin);
 };
 
@@ -272,5 +293,5 @@
 double atom::DistanceToVector(const Vector &origin) const
 {
-  return origin.distance(x);
+  return distance(origin);
 };
 
@@ -287,4 +308,21 @@
 };
 
+void atom::resetGraphNr(){
+  GraphNr=-1;
+}
+
+std::ostream & atom::operator << (std::ostream &ost) const
+{
+  ParticleInfo::operator<<(ost);
+  ost << "," << getPosition();
+  return ost;
+}
+
+std::ostream & operator << (std::ostream &ost, const atom &a)
+{
+  a.ParticleInfo::operator<<(ost);
+  ost << "," << a.getPosition();
+  return ost;
+}
 
 bool operator < (atom &a, atom &b)
@@ -321,4 +359,8 @@
 }
 
+/** Makes the atom be contained in the new molecule \a *_mol.
+ * Uses atom::removeFromMolecule() to delist from old molecule.
+ * \param *_mol pointer to new molecule
+ */
 void atom::setMolecule(molecule *_mol){
   // take this atom from the old molecule
@@ -326,12 +368,17 @@
   mol = _mol;
   if(!mol->containsAtom(this)){
-    mol->AddAtom(this);
-  }
-}
-
-molecule* atom::getMolecule(){
+    mol->insert(this);
+  }
+}
+
+/** Returns pointer to the molecule which atom belongs to.
+ * \return containing molecule
+ */
+molecule* atom::getMolecule() const {
   return mol;
 }
 
+/** Erases the atom in atom::mol's list of atoms and sets it to zero.
+ */
 void atom::removeFromMolecule(){
   if(mol){
@@ -343,4 +390,11 @@
 }
 
+double atom::getMass() const{
+  return getType()->getMass();
+}
+
+int atom::getNr() const{
+  return nr;
+}
 
 atom* NewAtom(atomId_t _id){
@@ -353,2 +407,6 @@
   delete atom;
 }
+
+bool compareAtomElements(atom* atom1,atom* atom2){
+  return atom1->getType()->getNumber() < atom2->getType()->getNumber();
+}
Index: src/atom.hpp
===================================================================
--- src/atom.hpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/atom.hpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -22,4 +22,5 @@
 #include <vector>
 
+#include "Helpers/helpers.hpp"
 #include "atom_atominfo.hpp"
 #include "atom_bondedparticle.hpp"
@@ -27,5 +28,5 @@
 #include "atom_particleinfo.hpp"
 #include "atom_trajectoryparticle.hpp"
-#include "tesselation.hpp"
+#include "TesselPoint.hpp"
 #include "types.hpp"
 
@@ -42,5 +43,5 @@
  * Class incorporates position, type
  */
-class atom : public TesselPoint, public TrajectoryParticle, public GraphNode, public BondedParticle, public virtual ParticleInfo, public virtual AtomInfo {
+class atom : public TrajectoryParticle, public GraphNode, public BondedParticle, public TesselPoint {
   friend atom* NewAtom(atomId_t);
   friend void  DeleteAtom(atom*);
@@ -52,13 +53,15 @@
 
   bool OutputIndexed(ofstream * const out, const int ElementNo, const int AtomNo, const char *comment = NULL) const;
-  bool OutputArrayIndexed(ostream * const out, const int *ElementNo, int *AtomNo, const char *comment = NULL) const;
+  bool OutputArrayIndexed(ostream * const out,const enumeration<const element*>&, int *AtomNo, const char *comment = NULL) const;
   bool OutputXYZLine(ofstream *out) const;
-  bool OutputTrajectory(ofstream * const out, const int *ElementNo, int *AtomNo, const int step) const;
+  bool OutputTrajectory(ofstream * const out, const enumeration<const element*>&, int *AtomNo, const int step) const;
   bool OutputTrajectoryXYZ(ofstream * const out, const int step) const;
-  void OutputMPQCLine(ostream * const out, const Vector *center, int *AtomNo) const;
+  void OutputMPQCLine(ostream * const out, const Vector *center) const;
 
   void InitComponentNr();
+  void resetGraphNr();
 
   void EqualsFather ( const atom *ptr, const atom **res ) const;
+  bool isFather(const atom *ptr);
   void CorrectFather();
   atom *GetTrueFather();
@@ -90,6 +93,12 @@
 
    void setMolecule(molecule*);
-   molecule* getMolecule();
+   molecule* getMolecule() const;
    void removeFromMolecule();
+
+   double getMass() const;
+   int getNr() const;
+
+   // Output operator
+   std::ostream & operator << (std::ostream &ost) const;
 
   protected:
@@ -119,4 +128,9 @@
 
 /**
+ * Global output operator for class atom.
+ */
+std::ostream & operator << (std::ostream &ost, const atom &_atom);
+
+/**
  * internal method used by the world. Do not use if you don't know what you are doing.
  * You might get burned...
@@ -132,4 +146,9 @@
 void  DeleteAtom(atom*);
 
+/**
+ * Simple function to compare atoms by their elements to allow sorting of atoms by this criteria
+ */
+bool compareAtomElements(atom* atom1,atom* atom2);
+
 
 #endif /* ATOM_HPP_ */
Index: src/atom_atominfo.cpp
===================================================================
--- src/atom_atominfo.cpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/atom_atominfo.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -1,2 +1,9 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
 /*
  * atom_atominfo.cpp
@@ -6,13 +13,33 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 #include "Helpers/MemDebug.hpp"
 
 #include "periodentafel.hpp"
 #include "World.hpp"
+#include "element.hpp"
 #include "atom_atominfo.hpp"
 
 /** Constructor of class AtomInfo.
  */
-AtomInfo::AtomInfo() : type(NULL) {};
+AtomInfo::AtomInfo() :
+  AtomicElement(NULL)
+{};
+
+/** Copy constructor of class AtomInfo.
+ */
+AtomInfo::AtomInfo(const AtomInfo &_atom) :
+    AtomicPosition(_atom.AtomicPosition),
+    AtomicElement(_atom.AtomicElement)
+{};
+
+AtomInfo::AtomInfo(const VectorInterface &_v) :
+    AtomicPosition(_v.getPosition()),
+    AtomicElement(NULL)
+{};
 
 /** Destructor of class AtomInfo.
@@ -22,14 +49,155 @@
 };
 
-const element *AtomInfo::getType(){
-  return type;
+const element *AtomInfo::getType() const
+{
+  return AtomicElement;
+}
+
+const double& AtomInfo::operator[](size_t i) const
+{
+  return AtomicPosition[i];
+}
+
+const double& AtomInfo::at(size_t i) const
+{
+  return AtomicPosition.at(i);
+}
+
+void AtomInfo::set(size_t i, const double value)
+{
+  AtomicPosition.at(i) = value;
+}
+
+const Vector& AtomInfo::getPosition() const
+{
+  return AtomicPosition;
 }
 
 void AtomInfo::setType(const element* _type) {
-  type = _type;
-}
-
-void AtomInfo::setType(int Z) {
+  AtomicElement = _type;
+}
+
+void AtomInfo::setType(const int Z) {
   const element *elem = World::getInstance().getPeriode()->FindElement(Z);
   setType(elem);
 }
+
+void AtomInfo::setPosition(const Vector& _vector)
+{
+  AtomicPosition = _vector;
+  //cout << "AtomInfo::setPosition: " << getType()->symbol << " at " << getPosition() << endl;
+}
+
+const VectorInterface& AtomInfo::operator+=(const Vector& b)
+{
+  AtomicPosition += b;
+  return *this;
+}
+
+const VectorInterface& AtomInfo::operator-=(const Vector& b)
+{
+  AtomicPosition -= b;
+  return *this;
+}
+
+Vector const AtomInfo::operator+(const Vector& b) const
+{
+  Vector a(AtomicPosition);
+  a += b;
+  return a;
+}
+
+Vector const AtomInfo::operator-(const Vector& b) const
+{
+  Vector a(AtomicPosition);
+  a -= b;
+  return a;
+}
+
+double AtomInfo::distance(const Vector &point) const
+{
+  return AtomicPosition.distance(point);
+}
+
+double AtomInfo::DistanceSquared(const Vector &y) const
+{
+  return AtomicPosition.DistanceSquared(y);
+}
+
+double AtomInfo::distance(const VectorInterface &_atom) const
+{
+  return _atom.distance(AtomicPosition);
+}
+
+double AtomInfo::DistanceSquared(const VectorInterface &_atom) const
+{
+  return _atom.DistanceSquared(AtomicPosition);
+}
+
+VectorInterface &AtomInfo::operator=(const Vector& _vector)
+{
+  AtomicPosition = _vector;
+  return *this;
+}
+
+void AtomInfo::ScaleAll(const double *factor)
+{
+  AtomicPosition.ScaleAll(factor);
+}
+
+void AtomInfo::ScaleAll(const Vector &factor)
+{
+  AtomicPosition.ScaleAll(factor);
+}
+
+void AtomInfo::Scale(const double factor)
+{
+  AtomicPosition.Scale(factor);
+}
+
+void AtomInfo::Zero()
+{
+  AtomicPosition.Zero();
+}
+
+void AtomInfo::One(const double one)
+{
+  AtomicPosition.One(one);
+}
+
+void AtomInfo::LinearCombinationOfVectors(const Vector &x1, const Vector &x2, const Vector &x3, const double * const factors)
+{
+  AtomicPosition.LinearCombinationOfVectors(x1,x2,x3,factors);
+}
+
+const AtomInfo& operator*=(AtomInfo& a, const double m)
+{
+  a.Scale(m);
+  return a;
+}
+
+AtomInfo const operator*(const AtomInfo& a, const double m)
+{
+  AtomInfo copy(a);
+  copy *= m;
+  return copy;
+}
+
+AtomInfo const operator*(const double m, const AtomInfo& a)
+{
+  AtomInfo copy(a);
+  copy *= m;
+  return copy;
+}
+
+std::ostream & AtomInfo::operator << (std::ostream &ost) const
+{
+  return (ost << getPosition());
+}
+
+std::ostream & operator << (std::ostream &ost, const AtomInfo &a)
+{
+  ost << a;
+  return ost;
+}
+
Index: src/atom_atominfo.hpp
===================================================================
--- src/atom_atominfo.hpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/atom_atominfo.hpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -19,28 +19,73 @@
 #endif
 
-#include "vector.hpp"
+#include "LinearAlgebra/Vector.hpp"
+#include "LinearAlgebra/VectorInterface.hpp"
 
 /****************************************** forward declarations *****************************/
 
+class AtomInfo;
 class element;
+class Matrix;
 
 /********************************************** declarations *******************************/
 
-class AtomInfo {
+class AtomInfo : public VectorInterface {
+
 public:
-  Vector x;       //!< coordinate vector of atom, giving last position within cell
-  Vector v;       //!< velocity vector of atom, giving last velocity within cell
-  Vector F;       //!< Force vector of atom, giving last force within cell
-  const element *type;  //!< pointing to element
+  Vector AtomicVelocity;       //!< velocity vector of atom, giving last velocity within cell
+  Vector AtomicForce;       //!< Force vector of atom, giving last force within cell
 
   AtomInfo();
-  ~AtomInfo();
+  AtomInfo(const AtomInfo &_atom);
+  AtomInfo(const VectorInterface &_v);
+  virtual ~AtomInfo();
 
-  const element *getType();
+  const element *getType() const;
   void setType(const element *);
-  void setType(int);
+  void setType(const int);
+
+  ///// manipulation of the atomic position
+
+  // Accessors ussually come in pairs... and sometimes even more than that
+  const double& operator[](size_t i) const;
+  const double& at(size_t i) const;
+  void set(size_t i, const double value);
+  const Vector& getPosition() const;
+
+  // Assignment operator
+  void setPosition(const Vector& _vector);
+  class VectorInterface &operator=(const Vector& _vector);
+
+  // operators for mathematical operations
+  const VectorInterface& operator+=(const Vector& b);
+  const VectorInterface& operator-=(const Vector& b);
+  Vector const operator+(const Vector& b) const;
+  Vector const operator-(const Vector& b) const;
+
+  void Zero();
+  void One(const double one);
+  void LinearCombinationOfVectors(const Vector &x1, const Vector &x2, const Vector &x3, const double * const factors);
+
+  double distance(const Vector &point) const;
+  double DistanceSquared(const Vector &y) const;
+  double distance(const VectorInterface &_atom) const;
+  double DistanceSquared(const VectorInterface &_atom) const;
+
+  void ScaleAll(const double *factor);
+  void ScaleAll(const Vector &factor);
+  void Scale(const double factor);
+
+  std::ostream & operator << (std::ostream &ost) const;
 
 private:
+  Vector AtomicPosition;       //!< coordinate vector of atom, giving last position within cell
+  const element *AtomicElement;  //!< pointing to element
 };
 
+std::ostream & operator << (std::ostream &ost, const AtomInfo &a);
+
+const AtomInfo& operator*=(AtomInfo& a, const double m);
+AtomInfo const operator*(const AtomInfo& a, const double m);
+AtomInfo const operator*(const double m, const AtomInfo& a);
+
 #endif /* ATOM_ATOMINFO_HPP_ */
Index: src/atom_bondedparticle.cpp
===================================================================
--- src/atom_bondedparticle.cpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/atom_bondedparticle.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -1,2 +1,9 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
 /*
  * atom_bondedparticle.cpp
@@ -6,4 +13,9 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 #include "Helpers/MemDebug.hpp"
 
@@ -13,6 +25,6 @@
 #include "element.hpp"
 #include "lists.hpp"
-#include "log.hpp"
-#include "verbose.hpp"
+#include "Helpers/Log.hpp"
+#include "Helpers/Verbose.hpp"
 
 /** Constructor of class BondedParticle.
@@ -152,10 +164,10 @@
   NoBonds = CountBonds();
   //Log() << Verbose(3) << "Walker " << *this << ": " << (int)this->type->NoValenceOrbitals << " > " << NoBonds << "?" << endl;
-  if ((int)(type->NoValenceOrbitals) > NoBonds) { // we have a mismatch, check all bonding partners for mismatch
+  if ((int)(getType()->getNoValenceOrbitals()) > NoBonds) { // we have a mismatch, check all bonding partners for mismatch
     for (BondList::const_iterator Runner = ListOfBonds.begin(); Runner != ListOfBonds.end(); (++Runner)) {
       OtherWalker = (*Runner)->GetOtherAtom(this);
       OtherNoBonds = OtherWalker->CountBonds();
       //Log() << Verbose(3) << "OtherWalker " << *OtherWalker << ": " << (int)OtherWalker->type->NoValenceOrbitals << " > " << OtherNoBonds << "?" << endl;
-      if ((int)(OtherWalker->type->NoValenceOrbitals) > OtherNoBonds) { // check if possible candidate
+      if ((int)(OtherWalker->getType()->getNoValenceOrbitals()) > OtherNoBonds) { // check if possible candidate
         if ((CandidateBond == NULL) || (ListOfBonds.size() > OtherWalker->ListOfBonds.size())) { // pick the one with fewer number of bonds first
           CandidateBond = (*Runner);
@@ -189,2 +201,16 @@
 };
 
+std::ostream & BondedParticle::operator << (std::ostream &ost) const
+{
+  ParticleInfo::operator<<(ost);
+  ost << "," << getPosition();
+  return ost;
+}
+
+std::ostream & operator << (std::ostream &ost, const BondedParticle &a)
+{
+  a.ParticleInfo::operator<<(ost);
+  ost << "," << a.getPosition();
+  return ost;
+}
+
Index: src/atom_bondedparticle.hpp
===================================================================
--- src/atom_bondedparticle.hpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/atom_bondedparticle.hpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -49,8 +49,11 @@
   void OutputOrder(ofstream *file) const;
 
+  std::ostream & operator << (std::ostream &ost) const;
+
 private:
 
 };
 
+std::ostream & operator << (std::ostream &ost, const BondedParticle &a);
 
 #endif /* ATOM_BONDEDPARTICLE_HPP_ */
Index: src/atom_bondedparticleinfo.cpp
===================================================================
--- src/atom_bondedparticleinfo.cpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/atom_bondedparticleinfo.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -1,2 +1,9 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
 /*
  * atom_bondedparticleinfo.cpp
@@ -6,4 +13,9 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 #include "Helpers/MemDebug.hpp"
 
@@ -12,5 +24,8 @@
 /** Constructor of class BondedParticleInfo.
  */
-BondedParticleInfo::BondedParticleInfo() : AdaptiveOrder(0), MaxOrder(false) {};
+BondedParticleInfo::BondedParticleInfo() :
+  AdaptiveOrder(0),
+  MaxOrder(false)
+{};
 
 /** Destructor of class BondedParticleInfo.
Index: src/atom_bondedparticleinfo.hpp
===================================================================
--- src/atom_bondedparticleinfo.hpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/atom_bondedparticleinfo.hpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -36,5 +36,5 @@
 
   BondedParticleInfo();
-  ~BondedParticleInfo();
+  virtual ~BondedParticleInfo();
 
 private:
Index: src/atom_graphnode.cpp
===================================================================
--- src/atom_graphnode.cpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/atom_graphnode.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -1,2 +1,9 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
 /*
  * atom_graphnode.cpp
@@ -6,9 +13,16 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 #include "Helpers/MemDebug.hpp"
 
+#include <iostream>
+
 #include "atom_graphnode.hpp"
-#include "log.hpp"
-#include "verbose.hpp"
+#include "Helpers/Log.hpp"
+#include "Helpers/Verbose.hpp"
 
 /** Constructor of class GraphNode.
@@ -29,6 +43,5 @@
 void GraphNode::OutputGraphInfo() const
 {
-  DoLog(2) && (Log() << Verbose(2) << "Atom " << getName() << " is " << ((SeparationVertex) ? "a" : "not a") << " separation vertex, components are ");
-  OutputComponentNumber();
+  DoLog(2) && (Log() << Verbose(2) << "Atom " << getName() << " is " << ((SeparationVertex) ? "a" : "not a") << " separation vertex, components are " << *this);
   DoLog(3) && (Log() << Verbose(3) << " with Lowpoint " << LowpointNr << " and Graph Nr. " << GraphNr << "." << endl);
 };
@@ -38,10 +51,15 @@
  * \param *out output stream for debugging
  */
-void GraphNode::OutputComponentNumber() const
+void GraphNode::OutputComponentNumber(ostream *out) const
 {
-  if (ComponentNr != NULL) {
-    for (int i=0; ComponentNr[i] != -1; i++)
-      DoLog(2) && (Log() << Verbose(2) << ComponentNr[i] << " ");
-  }
+  *out << *this;
 };
 
+ostream &operator<<(ostream &out, const GraphNode &a)
+{
+  if (a.ComponentNr != NULL) {
+    for (int i=0; a.ComponentNr[i] != -1; i++)
+      out << a.ComponentNr[i];
+  }
+  return out;
+}
Index: src/atom_graphnode.hpp
===================================================================
--- src/atom_graphnode.hpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/atom_graphnode.hpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -19,5 +19,5 @@
 #endif
 
-#include <fstream>
+#include <iosfwd>
 
 #include "atom_graphnodeinfo.hpp"
@@ -35,5 +35,5 @@
 
   void OutputGraphInfo() const;
-  void OutputComponentNumber() const;
+  void OutputComponentNumber(ostream *out) const;
 
 private:
@@ -41,3 +41,5 @@
 };
 
+ostream &operator<<(ostream &out, const GraphNode &a);
+
 #endif /* ATOM_GRAPHNODE_HPP_ */
Index: src/atom_graphnodeinfo.cpp
===================================================================
--- src/atom_graphnodeinfo.cpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/atom_graphnodeinfo.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -1,2 +1,9 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
 /*
  * atom_graphnodeinfo.cpp
@@ -6,4 +13,9 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 #include "Helpers/MemDebug.hpp"
 
@@ -12,5 +24,12 @@
 /** Constructor of class GraphNodeInfo.
  */
-GraphNodeInfo::GraphNodeInfo() : GraphNr(-1), ComponentNr(0), LowpointNr(-1), SeparationVertex(false), IsCyclic(false), Ancestor(0) {};
+GraphNodeInfo::GraphNodeInfo() :
+  GraphNr(-1),
+  ComponentNr(0),
+  LowpointNr(-1),
+  SeparationVertex(false),
+  IsCyclic(false),
+  Ancestor(0)
+{};
 
 /** Destructor of class GraphNodeInfo.
Index: src/atom_graphnodeinfo.hpp
===================================================================
--- src/atom_graphnodeinfo.hpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/atom_graphnodeinfo.hpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -37,5 +37,5 @@
 
   GraphNodeInfo();
-  ~GraphNodeInfo();
+  virtual ~GraphNodeInfo();
 private:
 
Index: src/atom_particleinfo.cpp
===================================================================
--- src/atom_particleinfo.cpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/atom_particleinfo.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -1,2 +1,9 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
 /*
  * atom_particleinfo.cpp
@@ -5,4 +12,9 @@
  *      Author: heber
  */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
 
 #include "Helpers/MemDebug.hpp"
@@ -14,11 +26,13 @@
 /** Constructor of ParticleInfo.
  */
-ParticleInfo::ParticleInfo() : nr(-1), name("Unknown") {
-};
+ParticleInfo::ParticleInfo() :
+  nr(-1),
+  name("Unknown")
+{};
 
 ParticleInfo::ParticleInfo(ParticleInfo *pointer) :
-    nr(pointer->nr),
-    name(pointer->name)
-    {}
+  nr(pointer->nr),
+  name(pointer->name)
+{}
 
 
@@ -38,5 +52,5 @@
 ostream & operator << (ostream &ost, const ParticleInfo &a)
 {
-  ost << "[" << a.getName() << "|" << &a << "]";
+  ost << a.getName();
   return ost;
 };
@@ -44,5 +58,5 @@
 ostream & ParticleInfo::operator << (ostream &ost) const
 {
-  ost << "[" << name << "|" << this << "]";
+  ost << getName();
   return ost;
 };
Index: src/atom_particleinfo.hpp
===================================================================
--- src/atom_particleinfo.hpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/atom_particleinfo.hpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -32,5 +32,5 @@
   ParticleInfo();
   ParticleInfo(ParticleInfo*);
-  ~ParticleInfo();
+  virtual ~ParticleInfo();
 
   const std::string& getName() const;
